【HDU】3506 Monkey Party】的更多相关文章

http://acm.hdu.edu.cn/showproblem.php?pid=3506 题意:环形石子合并取最小值= =(n<=1000) #include <cstdio> #include <algorithm> using namespace std; const int N=2005, oo=~0u>>1; int a[N], w[N], d[N][N], s[N][N], n; int main() { while(~scanf("%d&…
传送门:pid=4888">[HDU]4888 Redraw Beautiful Drawings 题目分析: 比赛的时候看出是个网络流,可是没有敲出来.各种反面样例推倒自己(究其原因是不愿意写暴力推断的).. 首先是简单的行列建边.源点向行建边.容量为该行元素和,汇点和列建边.容量为该列元素和.全部的行向全部的列建边,容量为K. 跑一次最大流.满流则有解,否则无解. 接下来是推断解是否唯一. 这个题解压根没看懂.还是暴力大法好. 最简单的思想就是枚举在一个矩形的四个端点.设A.D为主对角…
常规 事件 约束限制 调试 原文参见:http://www.douban.com/note/257030384/ 常规 –help 列出简单的用法. -v 命令行的每一个 -v 将增加反馈信息的级别. Level 0(缺省值)除启动提示.测试完成和最终结果之外,提供较少信息. Level 1提供较为详细的测试信息,如逐个发送到Activity的事件. Level 2提供更加详细的设置信息,如测试中被选中的或未被选中的Activity. 日志级别 Level 0 示例 adb shell monk…
原题目:悼念512汶川大地震遇难同胞——珍惜现在,感恩生活 [算法]多重背包(有限背包) 动态规划 [题解]http://blog.csdn.net/acdreamers/article/details/8563283 优化:若物品数量(num[i])*物品重量(w[i])>背包容量(m),就相当于无限背包. 对于num[i],可以拆成若干个01背包来实现1...num[i]的全覆盖,二进制原理: 1...k中的数可以由1.2.4...2t.k-2t+1+1(2t+2 > k ≥ 2t+1)组…
[题目]2017"百度之星"程序设计大赛 - 初赛(A) [题意]给定n个点的带边权树,m条编号1~m的路径,Q次询问编号区间[L,R]所有链的交集的长度.n<=500000. [算法]线段树+RMQ-LCA+树链的交 [题解]树链的交:记一条链为(a1,b1),LCA为c1.另一条链为(a2,b2),LCA为c2.记a1a2,a1b2,b1a2,b1b2的LCA为d1,d2,d3,d4,按深度排序后得deep[d1]<=deep[d2]<=deep[d3]<=…
[算法]数位DP [题意]定义V-number为从左到看单位数字未出现先递增后递减现象的数字,求0~N中满足条件的数字个数.T<=200,lenth(n)<=100 [题解]百度之星2017复赛,作为送分题出现,拿来练数位DP模板了. 位数多,读入记得用字符串. 记忆化要将有关变量全部纳入. 需要取模的时候别习惯性写"+=",特别是竞速赛,改起来很难受. -1的变量前加~就和0一样了. 最后自己造数据测试了一下,记忆化搜索的速度简直全面碾压递推啊!(从此坚定了信仰) #in…
[算法]trie [题解] 为了让数据有序,求lowbit无法直接排序,从而考虑倒过来排序,然后数据就会呈现出明显的规律: 法一:将数字倒着贴在字典树上,则容易发现两数的lowbit就是它们岔道结点的深度,所以先建树后对于一个数字依次把每次分岔开的另一边的size乘上权值累加答案. 法二:从高位到低位分组求和,即第一位1在上,0在下,则两边之间互相计算过后就再无影响,只剩下各自内部的事情再处理.由于排序后数据的有序性使分治可行. 法三:排序后对于一个数字,它和后面的数字的lowbit有单调性………
[算法]manacher [题解][算法]字符串 #include<cstdio> #include<algorithm> #include<cstring> using namespace std; ; int n,p[maxn]; char s[maxn],ss[maxn]; void manacher() { ,id=; ; ;i<=n;i++)//$不管 { if(i<mx) { p[i]=min(p[id*-i],mx-i+); } ; while…
[算法]AC自动机 [题解]本题注意题意是多少关键字能匹配而不是能匹配多少次,以及可能有重复单词. 询问时AC自动机与KMP最大的区别是因为建立了trie,所以对于目标串T与自动机串是否匹配只需要直接访问对应结点,而不用真的比较. 因此可以预处理出拥有对应节点的失配串,不用一次一次跑前跑去找一样的. 然后还有就是一个结点可能对应多个串,所以需要last使统计答案完整. AC自动机的细节标注在代码里了. AC自动机过程: [trie] for 长度 if(!ch[u][c])初始化,ch[u][c…
[算法]离散化 [题解] 答案一定存在于区间的左右端点.与区间左右端点距离0.5的点上 于是把所有坐标扩大一倍,排序(即离散化). 让某个点的前缀和表示该点的答案. 初始sum=∑c[i] 在l[i]处加上a[i]-c[i],在r[i]+1处加上b[i]-a[i]. 从左到右计算sum并比较出最大值即可. #include<cstdio> #include<algorithm> #include<cmath> #include<cstring> #inclu…
[题意]一个2*n的网格,再保证步数最少的情况下,求从任意格出发遍历完所有格的方案数,格子八连通.n<=10000,T<=100. [算法]递推,DP [题解]原题链接:蓝桥杯 格子刷油漆(动态规划) 这类题目最重要的是找到一个可以计算所有情况的状态表示. 对于2*x的网格,a[x]表示从左上角出发遍历完所有格子的方案数,b[x]表示从左上角出发遍历完所有格子并在左下角结束的方案数. 显然,b[x]=2*b[x-1]. 先考虑起点在左上角,有三种情况: ①先走到对面(左下角),再往右走,a[x…
今天忽然心血来潮打开牛客网尝试了一下一站到底 前四道题都是不到二十分钟切完,然后第五道来了道计算几何 我也不会啊,于是就觉得大力随机也许可行 然鹅被精度卡到崩溃 后来我才知道 保证有解,是保证你的精度误差设置到\(10^{-3}\),有解,\(10^{-5}\)没有解 [脏话] 这题直接随机三个点求外接圆就好了,看看这个圆上有几个点,期望随机十次左右吧 注意把题里说不合法的也就是绝对值大于1e9的这样的圆都给扔掉就好了 (这也许不是篇题解,只是一篇吐槽) #include <bits/stdc+…
http://acm.hdu.edu.cn/showproblem.php?pid=2138 题意:给n个数判断有几个素数.(每个数<=2^32) #include <cstdio> using namespace std; typedef long long ll; ll ipow(ll a, ll b, ll m) { ll x=1; for(; b; b>>=1, (a*=a)%=m) if(b&1) (x*=a)%=m; return x; } ll rand…
http://acm.hdu.edu.cn/showproblem.php?pid=1814 题意:n个2人组,编号分别为2n和2n+1,每个组选一个人出来,且给出m条关系(x,y)使得选了x就不能选y,问是否能从每个组选出1人.且输出字典序最小的答案.(n<=8000, m<=20000) #include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #in…
http://acm.hdu.edu.cn/showproblem.php?pid=2829 题意:将长度为n的序列分成p+1块,使得$\sum_{每块}\sum_{i<j} a[i]a[j]$最小(n<=1000,1<=a[i]<=100) #include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #include <iostream&…
http://acm.hdu.edu.cn/showproblem.php?pid=3480 题意:一个n个元素的集合S要求分成m个子集且子集并为S,要求$\sum_{S_i} (MAX-MIN)^2$最小.(n<=10000, m<=5000) #include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #include <iostream>…
http://acm.hdu.edu.cn/showproblem.php?pid=3516 题意:平面n个点且满足xi<xj, yi>yj, i<j.xi,yi均为整数.求一棵树边只能向上和向右延展的经过所有点的最小长度.(n<=1000, 0<=xi, yi<=10000) #include <cstdio> using namespace std; const int N=1005, oo=~0u>>1; int d[N][N], x[N]…
http://acm.hdu.edu.cn/showproblem.php?pid=4418 题意:一个0-n-1的坐标轴,给出起点X.终点Y,和初始方向D(0表示从左向右.1表示从右向左,-1表示起点或终点),在走的过程中如果到达起点或终点,那么下一步往反方向走.每次可以走1-m步,每步概率为p[i],问走到终点的期望步数.(n,m,X,Y<=100) #include <cstdio> #include <algorithm> #include <cstring&g…
http://acm.hdu.edu.cn/showproblem.php?pid=4089 题意: 有n个人排队等着在官网上激活游戏.主角排在第m个. 对于队列中的第一个人.有以下情况:1.激活失败,留在队列中等待下一次激活(概率为p1)2.失去连接,出队列,然后排在队列的最后(概率为p2)3.激活成功,离开队列(概率为p3)4.服务器瘫痪,服务器停止激活,所有人都无法激活了. 求服务器瘫痪时主角在队列中的位置<=k的概率 n, m<=1000, p1+p2+p3+p4=1 #include…
http://acm.hdu.edu.cn/showproblem.php?pid=4336 题意:n张卡片,每一次取一个盒子,盒子里装有卡片i的概率是p[i],求得到所有卡片所需要开的盒子的期望数(n<=20) #include <cstdio> #include <cstring> using namespace std; const int N=22; int n; double p[N], f[1<<N]; int main() { while(~scan…
http://acm.hdu.edu.cn/showproblem.php?pid=4035 题意:给一棵n个节点的树,每个节点有值k[i]和e[i],分别表示k[i]概率走向1号节点,e[i]概率获得胜利(即停止),如果没有进行上边任意操作,则等概率的走向与这个节点连边的点.问走过的边的期望.(n<=10000) #include <cstdio> #include <cstring> using namespace std; const int N=10005; cons…
http://acm.hdu.edu.cn/showproblem.php?pid=3853 题意:n×m的格子,起始在(1,1),要求走到(n,m),在每一格(i,j)有三种走法,其中p[i,j,0]的概率留在原地,p[i,j,1]的概率走到(i,j+1),p[i,j,2]的概率走到(i+1, j),问期望步数.(n,m<=1000) #include <cstdio> #include <cstring> using namespace std; const int N=…
http://acm.hdu.edu.cn/showproblem.php?pid=4405 题意:每次可以走1~6格,初始化在第0格,走到>=n的格子就结束.还有m个传送门,表示可以从X[i]格传送到Y[i]而不需要消耗次数,X[i]<Y[i].n<=100000, m<=1000. #include <cstdio> #include <cstring> using namespace std; double d[100010]; int n, m, m…
http://acm.hdu.edu.cn/showproblem.php?pid=2147 题意:n×m的棋盘,每次可以向左走.向下走.向左下走,初始在(1, m),n,m<=2000,问先手是否胜利. #include <cstdio> using namespace std; int main() { int n, m; while(scanf("%d%d", &n, &m), n|m) (n&1)&&(m&1)?…
http://acm.hdu.edu.cn/showproblem.php?pid=1517 题意:每次乘上2~9..p>=n时赢.. #include <cstdio> #include <cstring> #include <map> using namespace std; typedef long long ll; map<ll, bool> h; ll n; bool dfs(ll p) { if(p>=n) return 0; if(…
http://acm.hdu.edu.cn/showproblem.php?pid=1850 题意:同nim...顺便求方案数... #include <cstdio> #include <cstring> using namespace std; int a[105]; int main() { int n; while(scanf("%d", &n), n) { int ans=0, t, as=0; for(int i=0; i<n; ++i…
http://acm.hdu.edu.cn/showproblem.php?pid=1536 题意:同nim...多堆多询问...单堆n<=10000,每次取的是给定集合的数= = #include <cstdio> #include <cstring> using namespace std; bool b[105]; int s[105], f[10005]; int main() { int k, m, n; while(scanf("%d", &a…
http://acm.hdu.edu.cn/showproblem.php?pid=1848 题意:同nim,3堆,每次取的为fib数,n<=1000 #include <cstdio> #include <cstring> using namespace std; int f[1005], a[100]; bool b[20]; int main() { a[1]=1; a[2]=2; for(int i=3; i<=15; ++i) a[i]=a[i-1]+a[i-…
http://acm.hdu.edu.cn/showproblem.php?pid=1847 题意:同nim..不过只有一堆..每次取2的幂次..即1.2.4....等,n<=1000 #include <cstdio> #include <cstring> using namespace std; int f[1005]; int dfs(int n) { if(n==0) return 0; if(f[n]!=-1) return f[n]; for(int i=1024…
http://acm.hdu.edu.cn/showproblem.php?pid=1846 题意:二人博弈,1堆石子每次取1~m个,没有石子可取的输,输出先手胜利还是后手胜利. #include <cstdio> using namespace std; int main() { int c; scanf("%d", &c); while(c--) { int n, m; scanf("%d%d", &n, &m); print…